Super Jumping! Jumping! Jumping!
Description
Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good
boy, and know little about this game, so I introduce it to you now.
The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and
all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into
end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one
chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players
cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can
straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if
he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen
in you jumping path.
Your task is to output the maximum value according to the given chessmen list.
Your task is to output the maximum value according to the given chessmen list.
Input
Input contains multiple test cases. Each test case is described in a line as follow:
N value_1 value_2 …value_N
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
A test case starting with 0 terminates the input and this test case is not to be processed.
N value_1 value_2 …value_N
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
A test case starting with 0 terminates the input and this test case is not to be processed.
Output
For each case, print the maximum according to rules, and one line one case.
Sample Input
3 1 3 2 4 1 2 3 4 4 3 3 2 1 0
Sample Output
4 10 3思路:类似最长上升子序列的写法,d[i]表示如果第i个元素是最后一个元素,能达到的最大值是多少。d[i]=max{d[j]+a[i], j<i , a[j]<a[i]}.>>AC代码:#include <iostream> #include <algorithm> using namespace std; int N,ans; int a[1001],dp[1001]; int main(){ while(cin>>N&&N){ ans=0; memset(a,0,sizeof(a)); memset(dp,0,sizeof(dp)); for(int i=1;i<=N;i++){ scanf("%d",a+i); a[0]=dp[0]=0; ans=max(ans,dp[i]=a[i]); for(int j=1;j<i;j++){ if(a[j]<a[i]){ ans=max(ans,dp[i]=max(dp[i],dp[j]+a[i]));//刚开始dp[i]都初始化为a[i],后续要做的就是在1到i这个区间内找比a[i]小的数,找到了,就比较,注意:dp[j]+a[i]这样是由于dp[j]在前面已经确定,就是前j个数的最大连续上升和值,所以每当i+1,执行j=1;j<i;j++循环,此时dp[i]大小有待确定,但又与dp[i-1],dp[i-2],dp[i-3]..到dp[1]环环相扣,因此需要一个j循环,依次确定大小,递推出dp[i]的最大值。第一个ans则初始化dp,第二个则不断更新dp[i]的最大值 } } } cout<<ans<<endl; } return 0; }